#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 221
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 107
#define ALIAS_COUNT 1
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 19
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 29

enum {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_module = 3,
  anon_sym_LPAREN = 4,
  anon_sym_COMMA = 5,
  anon_sym_RPAREN = 6,
  anon_sym_function = 7,
  anon_sym_EQ = 8,
  anon_sym_include = 9,
  anon_sym_use = 10,
  sym_include_path = 11,
  anon_sym_LBRACE = 12,
  anon_sym_RBRACE = 13,
  anon_sym_for = 14,
  anon_sym_intersection_for = 15,
  anon_sym_let = 16,
  anon_sym_assign = 17,
  anon_sym_if = 18,
  anon_sym_else = 19,
  anon_sym_STAR = 20,
  anon_sym_BANG = 21,
  anon_sym_POUND = 22,
  anon_sym_PERCENT = 23,
  anon_sym_LBRACK = 24,
  anon_sym_COLON = 25,
  anon_sym_RBRACK = 26,
  anon_sym_each = 27,
  anon_sym_DOT = 28,
  anon_sym_DASH = 29,
  anon_sym_PLUS = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_AMP_AMP = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_LT = 35,
  anon_sym_GT = 36,
  anon_sym_LT_EQ = 37,
  anon_sym_GT_EQ = 38,
  anon_sym_SLASH = 39,
  anon_sym_CARET = 40,
  anon_sym_QMARK = 41,
  anon_sym_assert = 42,
  anon_sym_DOLLAR = 43,
  sym_string = 44,
  sym_decimal = 45,
  sym_float = 46,
  anon_sym_true = 47,
  anon_sym_false = 48,
  sym_undef = 49,
  sym_comment = 50,
  sym_source_file = 51,
  sym__item = 52,
  sym_module_declaration = 53,
  sym_parameters_declaration = 54,
  sym__parameter_declaration = 55,
  sym_function_declaration = 56,
  sym__statement = 57,
  sym_include_statement = 58,
  sym_use_statement = 59,
  sym_assignment = 60,
  sym_union_block = 61,
  sym_for_block = 62,
  sym_intersection_for_block = 63,
  sym_let_block = 64,
  sym_assign_block = 65,
  sym_if_block = 66,
  sym_modifier_chain = 67,
  sym_modifier = 68,
  sym_transform_chain = 69,
  sym_module_call = 70,
  sym_arguments = 71,
  sym_parenthesized_assignments = 72,
  sym_parenthesized_expression = 73,
  sym_condition_update_clause = 74,
  sym_expression = 75,
  sym_let_expression = 76,
  sym_literal = 77,
  sym_function = 78,
  sym_range = 79,
  sym_list = 80,
  sym__list_cell = 81,
  sym__comprehension_cell = 82,
  sym_each = 83,
  sym_list_comprehension = 84,
  sym_for_clause = 85,
  sym_if_clause = 86,
  sym_function_call = 87,
  sym_index_expression = 88,
  sym_dot_index_expression = 89,
  sym_unary_expression = 90,
  sym_binary_expression = 91,
  sym_ternary_expression = 92,
  sym__assert_clause = 93,
  sym_assert_statement = 94,
  sym_assert_expression = 95,
  sym_special_variable = 96,
  sym__variable_name = 97,
  sym_number = 98,
  sym_boolean = 99,
  aux_sym_source_file_repeat1 = 100,
  aux_sym_parameters_declaration_repeat1 = 101,
  aux_sym_union_block_repeat1 = 102,
  aux_sym_arguments_repeat1 = 103,
  aux_sym_parenthesized_assignments_repeat1 = 104,
  aux_sym_list_repeat1 = 105,
  aux_sym__assert_clause_repeat1 = 106,
  alias_sym_parameter = 107,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_module] = "module",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_function] = "function",
  [anon_sym_EQ] = "=",
  [anon_sym_include] = "include",
  [anon_sym_use] = "use",
  [sym_include_path] = "include_path",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_for] = "for",
  [anon_sym_intersection_for] = "intersection_for",
  [anon_sym_let] = "let",
  [anon_sym_assign] = "assign",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_STAR] = "*",
  [anon_sym_BANG] = "!",
  [anon_sym_POUND] = "#",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LBRACK] = "[",
  [anon_sym_COLON] = ":",
  [anon_sym_RBRACK] = "]",
  [anon_sym_each] = "each",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_SLASH] = "/",
  [anon_sym_CARET] = "^",
  [anon_sym_QMARK] = "\?",
  [anon_sym_assert] = "assert",
  [anon_sym_DOLLAR] = "$",
  [sym_string] = "string",
  [sym_decimal] = "decimal",
  [sym_float] = "float",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_undef] = "undef",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__item] = "_item",
  [sym_module_declaration] = "module_declaration",
  [sym_parameters_declaration] = "parameters_declaration",
  [sym__parameter_declaration] = "_parameter_declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__statement] = "_statement",
  [sym_include_statement] = "include_statement",
  [sym_use_statement] = "use_statement",
  [sym_assignment] = "assignment",
  [sym_union_block] = "union_block",
  [sym_for_block] = "for_block",
  [sym_intersection_for_block] = "intersection_for_block",
  [sym_let_block] = "let_block",
  [sym_assign_block] = "assign_block",
  [sym_if_block] = "if_block",
  [sym_modifier_chain] = "modifier_chain",
  [sym_modifier] = "modifier",
  [sym_transform_chain] = "transform_chain",
  [sym_module_call] = "module_call",
  [sym_arguments] = "arguments",
  [sym_parenthesized_assignments] = "parenthesized_assignments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_condition_update_clause] = "condition_update_clause",
  [sym_expression] = "expression",
  [sym_let_expression] = "let_expression",
  [sym_literal] = "literal",
  [sym_function] = "function",
  [sym_range] = "range",
  [sym_list] = "list",
  [sym__list_cell] = "_list_cell",
  [sym__comprehension_cell] = "_comprehension_cell",
  [sym_each] = "each",
  [sym_list_comprehension] = "list_comprehension",
  [sym_for_clause] = "for_clause",
  [sym_if_clause] = "if_clause",
  [sym_function_call] = "function_call",
  [sym_index_expression] = "index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym__assert_clause] = "_assert_clause",
  [sym_assert_statement] = "assert_statement",
  [sym_assert_expression] = "assert_expression",
  [sym_special_variable] = "special_variable",
  [sym__variable_name] = "_variable_name",
  [sym_number] = "number",
  [sym_boolean] = "boolean",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_parameters_declaration_repeat1] = "parameters_declaration_repeat1",
  [aux_sym_union_block_repeat1] = "union_block_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_parenthesized_assignments_repeat1] = "parenthesized_assignments_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__assert_clause_repeat1] = "_assert_clause_repeat1",
  [alias_sym_parameter] = "parameter",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_use] = anon_sym_use,
  [sym_include_path] = sym_include_path,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_intersection_for] = anon_sym_intersection_for,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_assign] = anon_sym_assign,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_each] = anon_sym_each,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [sym_string] = sym_string,
  [sym_decimal] = sym_decimal,
  [sym_float] = sym_float,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_undef] = sym_undef,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__item] = sym__item,
  [sym_module_declaration] = sym_module_declaration,
  [sym_parameters_declaration] = sym_parameters_declaration,
  [sym__parameter_declaration] = sym__parameter_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__statement] = sym__statement,
  [sym_include_statement] = sym_include_statement,
  [sym_use_statement] = sym_use_statement,
  [sym_assignment] = sym_assignment,
  [sym_union_block] = sym_union_block,
  [sym_for_block] = sym_for_block,
  [sym_intersection_for_block] = sym_intersection_for_block,
  [sym_let_block] = sym_let_block,
  [sym_assign_block] = sym_assign_block,
  [sym_if_block] = sym_if_block,
  [sym_modifier_chain] = sym_modifier_chain,
  [sym_modifier] = sym_modifier,
  [sym_transform_chain] = sym_transform_chain,
  [sym_module_call] = sym_module_call,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_assignments] = sym_parenthesized_assignments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_condition_update_clause] = sym_condition_update_clause,
  [sym_expression] = sym_expression,
  [sym_let_expression] = sym_let_expression,
  [sym_literal] = sym_literal,
  [sym_function] = sym_function,
  [sym_range] = sym_range,
  [sym_list] = sym_list,
  [sym__list_cell] = sym__list_cell,
  [sym__comprehension_cell] = sym__comprehension_cell,
  [sym_each] = sym_each,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_for_clause] = sym_for_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_function_call] = sym_function_call,
  [sym_index_expression] = sym_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym__assert_clause] = sym__assert_clause,
  [sym_assert_statement] = sym_assert_statement,
  [sym_assert_expression] = sym_assert_expression,
  [sym_special_variable] = sym_special_variable,
  [sym__variable_name] = sym__variable_name,
  [sym_number] = sym_number,
  [sym_boolean] = sym_boolean,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_parameters_declaration_repeat1] = aux_sym_parameters_declaration_repeat1,
  [aux_sym_union_block_repeat1] = aux_sym_union_block_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_parenthesized_assignments_repeat1] = aux_sym_parenthesized_assignments_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
  [aux_sym__assert_clause_repeat1] = aux_sym__assert_clause_repeat1,
  [alias_sym_parameter] = alias_sym_parameter,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [sym_include_path] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_intersection_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_each] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__item] = {
    .visible = false,
    .named = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_include_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_use_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_union_block] = {
    .visible = true,
    .named = true,
  },
  [sym_for_block] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_for_block] = {
    .visible = true,
    .named = true,
  },
  [sym_let_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assign_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_block] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_transform_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_module_call] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_assignments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_update_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_let_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__list_cell] = {
    .visible = false,
    .named = true,
  },
  [sym__comprehension_cell] = {
    .visible = false,
    .named = true,
  },
  [sym_each] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__assert_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_special_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_name] = {
    .visible = false,
    .named = true,
  },
  [sym_number] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_assignments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__assert_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_parameter] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_condition = 4,
  field_consequence = 5,
  field_end = 6,
  field_function = 7,
  field_increment = 8,
  field_index = 9,
  field_initializer = 10,
  field_left = 11,
  field_message = 12,
  field_name = 13,
  field_parameters = 14,
  field_right = 15,
  field_start = 16,
  field_trailing_args = 17,
  field_update = 18,
  field_value = 19,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_end] = "end",
  [field_function] = "function",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_message] = "message",
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_trailing_args] = "trailing_args",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 3},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 2},
  [7] = {.index = 10, .length = 3},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 1},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 4},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 3},
  [17] = {.index = 33, .length = 3},
  [18] = {.index = 36, .length = 3},
  [19] = {.index = 39, .length = 3},
  [20] = {.index = 42, .length = 4},
  [21] = {.index = 46, .length = 2},
  [22] = {.index = 48, .length = 2},
  [23] = {.index = 50, .length = 3},
  [24] = {.index = 53, .length = 3},
  [25] = {.index = 56, .length = 3},
  [26] = {.index = 59, .length = 4},
  [27] = {.index = 63, .length = 4},
  [28] = {.index = 67, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 1},
    {field_name, 0},
  [2] =
    {field_condition, 0, .inherited = true},
    {field_message, 0, .inherited = true},
    {field_trailing_args, 0, .inherited = true},
  [5] =
    {field_body, 2},
  [6] =
    {field_condition, 1},
    {field_consequence, 2},
  [8] =
    {field_left, 0},
    {field_right, 2},
  [10] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [13] =
    {field_arguments, 1},
    {field_function, 0},
  [15] =
    {field_condition, 2},
  [16] =
    {field_name, 1},
    {field_parameters, 2},
  [18] =
    {field_body, 2},
    {field_parameters, 1},
  [20] =
    {field_index, 2},
    {field_value, 0},
  [22] =
    {field_alternative, 3},
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [26] =
    {field_condition, 2},
    {field_message, 4},
  [28] =
    {field_end, 3},
    {field_start, 1},
  [30] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [33] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [36] =
    {field_condition, 2},
    {field_message, 4},
    {field_trailing_args, 6},
  [39] =
    {field_end, 5},
    {field_increment, 3},
    {field_start, 1},
  [42] =
    {field_condition, 2},
    {field_message, 4},
    {field_trailing_args, 6},
    {field_trailing_args, 7},
  [46] =
    {field_condition, 2},
    {field_update, 4},
  [48] =
    {field_condition, 3},
    {field_initializer, 1},
  [50] =
    {field_condition, 2},
    {field_update, 4},
    {field_update, 5},
  [53] =
    {field_condition, 3},
    {field_initializer, 1},
    {field_update, 5},
  [56] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
  [59] =
    {field_condition, 3},
    {field_initializer, 1},
    {field_update, 5},
    {field_update, 6},
  [63] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 6},
  [67] =
    {field_condition, 4},
    {field_initializer, 1},
    {field_initializer, 2},
    {field_update, 6},
    {field_update, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = alias_sym_parameter,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__variable_name, 2,
    sym__variable_name,
    alias_sym_parameter,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 57,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 130,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 26,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(15);
      if (lookahead == '!') ADVANCE(27);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(28);
      if (lookahead == '$') ADVANCE(50);
      if (lookahead == '%') ADVANCE(29);
      if (lookahead == '&') ADVANCE(4);
      if (lookahead == '(') ADVANCE(17);
      if (lookahead == ')') ADVANCE(19);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '+') ADVANCE(37);
      if (lookahead == ',') ADVANCE(18);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(34);
      if (lookahead == '/') ADVANCE(46);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == ';') ADVANCE(16);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(21);
      if (lookahead == '>') ADVANCE(43);
      if (lookahead == '?') ADVANCE(48);
      if (lookahead == '[') ADVANCE(30);
      if (lookahead == ']') ADVANCE(32);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '{') ADVANCE(23);
      if (lookahead == '|') ADVANCE(10);
      if (lookahead == '}') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(26);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(28);
      if (lookahead == '$') ADVANCE(50);
      if (lookahead == '%') ADVANCE(29);
      if (lookahead == '(') ADVANCE(17);
      if (lookahead == ')') ADVANCE(19);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '+') ADVANCE(37);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '.') ADVANCE(11);
      if (lookahead == '/') ADVANCE(5);
      if (lookahead == ';') ADVANCE(16);
      if (lookahead == '<') ADVANCE(9);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '[') ADVANCE(30);
      if (lookahead == ']') ADVANCE(32);
      if (lookahead == '{') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 4:
      if (lookahead == '&') ADVANCE(39);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(57);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(56);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '-') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(55);
      END_STATE();
    case 9:
      if (lookahead == '>') ADVANCE(22);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '|') ADVANCE(38);
      END_STATE();
    case 11:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(54);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(55);
      END_STATE();
    case 13:
      if (lookahead != 0 &&
          lookahead != '\r') ADVANCE(57);
      if (lookahead == '\r') ADVANCE(58);
      END_STATE();
    case 14:
      if (eof) ADVANCE(15);
      if (lookahead == '!') ADVANCE(27);
      if (lookahead == '#') ADVANCE(28);
      if (lookahead == '$') ADVANCE(50);
      if (lookahead == '%') ADVANCE(29);
      if (lookahead == '&') ADVANCE(4);
      if (lookahead == '(') ADVANCE(17);
      if (lookahead == ')') ADVANCE(19);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '+') ADVANCE(37);
      if (lookahead == ',') ADVANCE(18);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == '/') ADVANCE(46);
      if (lookahead == ':') ADVANCE(31);
      if (lookahead == ';') ADVANCE(16);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(21);
      if (lookahead == '>') ADVANCE(43);
      if (lookahead == '?') ADVANCE(48);
      if (lookahead == '[') ADVANCE(30);
      if (lookahead == ']') ADVANCE(32);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '{') ADVANCE(23);
      if (lookahead == '|') ADVANCE(10);
      if (lookahead == '}') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(40);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_include_path);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(41);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(54);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(7);
      if (lookahead == '/') ADVANCE(57);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_decimal);
      if (lookahead == '.') ADVANCE(11);
      if (lookahead == 'e') ADVANCE(8);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(53);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'e') ADVANCE(8);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(57);
      if (lookahead == '\\') ADVANCE(13);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'e') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'l') ADVANCE(5);
      if (lookahead == 'm') ADVANCE(6);
      if (lookahead == 't') ADVANCE(7);
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(9);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(10);
      if (lookahead == 'l') ADVANCE(11);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(14);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(17);
      END_STATE();
    case 6:
      if (lookahead == 'o') ADVANCE(18);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(19);
      END_STATE();
    case 8:
      if (lookahead == 'n') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 9:
      if (lookahead == 's') ADVANCE(22);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(23);
      END_STATE();
    case 11:
      if (lookahead == 's') ADVANCE(24);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(25);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 14:
      if (lookahead == 'n') ADVANCE(27);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 16:
      if (lookahead == 'c') ADVANCE(28);
      if (lookahead == 't') ADVANCE(29);
      END_STATE();
    case 17:
      if (lookahead == 't') ADVANCE(30);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(31);
      END_STATE();
    case 19:
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 20:
      if (lookahead == 'd') ADVANCE(33);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(37);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(39);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 27:
      if (lookahead == 'c') ADVANCE(40);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(45);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 35:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 36:
      if (lookahead == 'g') ADVANCE(47);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_each);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(49);
      END_STATE();
    case 41:
      if (lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 45:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(57);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(59);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_undef);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_assign);
      END_STATE();
    case 56:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_include);
      END_STATE();
    case 62:
      if (lookahead == 'c') ADVANCE(64);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == '_') ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 'f') ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'r') ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_intersection_for);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 1},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 1},
  [7] = {.lex_state = 1},
  [8] = {.lex_state = 1},
  [9] = {.lex_state = 14},
  [10] = {.lex_state = 14},
  [11] = {.lex_state = 14},
  [12] = {.lex_state = 14},
  [13] = {.lex_state = 14},
  [14] = {.lex_state = 14},
  [15] = {.lex_state = 1},
  [16] = {.lex_state = 14},
  [17] = {.lex_state = 14},
  [18] = {.lex_state = 14},
  [19] = {.lex_state = 14},
  [20] = {.lex_state = 14},
  [21] = {.lex_state = 14},
  [22] = {.lex_state = 14},
  [23] = {.lex_state = 14},
  [24] = {.lex_state = 14},
  [25] = {.lex_state = 14},
  [26] = {.lex_state = 14},
  [27] = {.lex_state = 14},
  [28] = {.lex_state = 14},
  [29] = {.lex_state = 14},
  [30] = {.lex_state = 14},
  [31] = {.lex_state = 14},
  [32] = {.lex_state = 14},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 14},
  [35] = {.lex_state = 14},
  [36] = {.lex_state = 14},
  [37] = {.lex_state = 0},
  [38] = {.lex_state = 14},
  [39] = {.lex_state = 14},
  [40] = {.lex_state = 14},
  [41] = {.lex_state = 14},
  [42] = {.lex_state = 14},
  [43] = {.lex_state = 14},
  [44] = {.lex_state = 14},
  [45] = {.lex_state = 1},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 0},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 14},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 1},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 1},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 1},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 1},
  [96] = {.lex_state = 1},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 1},
  [101] = {.lex_state = 1},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 1},
  [104] = {.lex_state = 14},
  [105] = {.lex_state = 14},
  [106] = {.lex_state = 14},
  [107] = {.lex_state = 14},
  [108] = {.lex_state = 14},
  [109] = {.lex_state = 14},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 14},
  [112] = {.lex_state = 14},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 14},
  [119] = {.lex_state = 14},
  [120] = {.lex_state = 14},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 14},
  [127] = {.lex_state = 14},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 14},
  [130] = {.lex_state = 14},
  [131] = {.lex_state = 14},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 14},
  [134] = {.lex_state = 14},
  [135] = {.lex_state = 14},
  [136] = {.lex_state = 14},
  [137] = {.lex_state = 14},
  [138] = {.lex_state = 0},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 0},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 0},
  [151] = {.lex_state = 0},
  [152] = {.lex_state = 0},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 0},
  [155] = {.lex_state = 0},
  [156] = {.lex_state = 0},
  [157] = {.lex_state = 0},
  [158] = {.lex_state = 0},
  [159] = {.lex_state = 0},
  [160] = {.lex_state = 0},
  [161] = {.lex_state = 0},
  [162] = {.lex_state = 0},
  [163] = {.lex_state = 0},
  [164] = {.lex_state = 0},
  [165] = {.lex_state = 0},
  [166] = {.lex_state = 0},
  [167] = {.lex_state = 0},
  [168] = {.lex_state = 0},
  [169] = {.lex_state = 0},
  [170] = {.lex_state = 0},
  [171] = {.lex_state = 0},
  [172] = {.lex_state = 0},
  [173] = {.lex_state = 0},
  [174] = {.lex_state = 0},
  [175] = {.lex_state = 0},
  [176] = {.lex_state = 0},
  [177] = {.lex_state = 0},
  [178] = {.lex_state = 0},
  [179] = {.lex_state = 0},
  [180] = {.lex_state = 0},
  [181] = {.lex_state = 0},
  [182] = {.lex_state = 0},
  [183] = {.lex_state = 0},
  [184] = {.lex_state = 0},
  [185] = {.lex_state = 0},
  [186] = {.lex_state = 0},
  [187] = {.lex_state = 0},
  [188] = {.lex_state = 0},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 0},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 0},
  [193] = {.lex_state = 0},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 0},
  [196] = {.lex_state = 0},
  [197] = {.lex_state = 0},
  [198] = {.lex_state = 0},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 0},
  [206] = {.lex_state = 0},
  [207] = {.lex_state = 0},
  [208] = {.lex_state = 0},
  [209] = {.lex_state = 0},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 0},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0},
  [216] = {.lex_state = 1},
  [217] = {.lex_state = 0},
  [218] = {.lex_state = 1},
  [219] = {.lex_state = 0},
  [220] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_intersection_for] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_assign] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_each] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_decimal] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_undef] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(210),
    [sym__item] = STATE(33),
    [sym_module_declaration] = STATE(33),
    [sym_function_declaration] = STATE(33),
    [sym__statement] = STATE(33),
    [sym_include_statement] = STATE(33),
    [sym_use_statement] = STATE(33),
    [sym_assignment] = STATE(212),
    [sym_union_block] = STATE(33),
    [sym_for_block] = STATE(33),
    [sym_intersection_for_block] = STATE(33),
    [sym_let_block] = STATE(33),
    [sym_assign_block] = STATE(33),
    [sym_if_block] = STATE(33),
    [sym_modifier_chain] = STATE(33),
    [sym_modifier] = STATE(84),
    [sym_transform_chain] = STATE(33),
    [sym_module_call] = STATE(85),
    [sym__assert_clause] = STATE(86),
    [sym_assert_statement] = STATE(33),
    [sym_special_variable] = STATE(22),
    [sym__variable_name] = STATE(213),
    [aux_sym_source_file_repeat1] = STATE(33),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(13),
    [anon_sym_include] = ACTIONS(15),
    [anon_sym_use] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_for] = ACTIONS(21),
    [anon_sym_intersection_for] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_assign] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_POUND] = ACTIONS(31),
    [anon_sym_PERCENT] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_DOLLAR] = ACTIONS(35),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(53), 1,
      anon_sym_RBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(112), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(198), 3,
      sym__list_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [98] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(69), 1,
      anon_sym_RBRACK,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(112), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(198), 3,
      sym__list_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [196] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(71), 1,
      anon_sym_RBRACK,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(107), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(178), 3,
      sym__list_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [294] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(104), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(163), 3,
      sym__comprehension_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [389] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(104), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(164), 3,
      sym__comprehension_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [484] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(73), 1,
      anon_sym_LPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(104), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(162), 3,
      sym__comprehension_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [579] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(112), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(198), 3,
      sym__list_cell,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [674] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(75), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
    ACTIONS(77), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(107), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(105), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(107), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(105), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(111), 15,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(109), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [934] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(113), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
    ACTIONS(115), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [1012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(107), 15,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(105), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1078] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_each,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(135), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(211), 2,
      sym_each,
      sym_list_comprehension,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [1172] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(111), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(109), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1230] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(117), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
    ACTIONS(119), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [1308] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(121), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
    ACTIONS(123), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [1386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 17,
      anon_sym_module,
      anon_sym_function,
      anon_sym_EQ,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(125), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1436] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(107), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(105), 15,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(105), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(107), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [1578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 17,
      anon_sym_module,
      anon_sym_function,
      anon_sym_EQ,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(129), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1628] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(105), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(107), 13,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [1702] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(107), 15,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(105), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(133), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(139), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(137), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(143), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(141), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(145), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [1962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(151), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(149), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(153), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(159), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(157), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(163), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(161), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_function,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(17), 1,
      anon_sym_use,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(165), 1,
      ts_builtin_sym_end,
    ACTIONS(167), 1,
      anon_sym_SEMI,
    STATE(22), 1,
      sym_special_variable,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    STATE(212), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(37), 16,
      sym__item,
      sym_module_declaration,
      sym_function_declaration,
      sym__statement,
      sym_include_statement,
      sym_use_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
      aux_sym_source_file_repeat1,
  [2249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(171), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(169), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(173), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(177), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2396] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(181), 1,
      ts_builtin_sym_end,
    ACTIONS(183), 1,
      sym_identifier,
    ACTIONS(186), 1,
      anon_sym_SEMI,
    ACTIONS(189), 1,
      anon_sym_module,
    ACTIONS(192), 1,
      anon_sym_function,
    ACTIONS(195), 1,
      anon_sym_include,
    ACTIONS(198), 1,
      anon_sym_use,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(204), 1,
      anon_sym_for,
    ACTIONS(207), 1,
      anon_sym_intersection_for,
    ACTIONS(210), 1,
      anon_sym_let,
    ACTIONS(213), 1,
      anon_sym_assign,
    ACTIONS(216), 1,
      anon_sym_if,
    ACTIONS(222), 1,
      anon_sym_assert,
    ACTIONS(225), 1,
      anon_sym_DOLLAR,
    STATE(22), 1,
      sym_special_variable,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    STATE(212), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
    ACTIONS(219), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(37), 16,
      sym__item,
      sym_module_declaration,
      sym_function_declaration,
      sym__statement,
      sym_include_statement,
      sym_use_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
      aux_sym_source_file_repeat1,
  [2487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(230), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(228), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(234), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(232), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(238), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(236), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(242), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(240), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(246), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(244), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(250), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(248), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(254), 16,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_assert,
      sym_identifier,
    ACTIONS(252), 25,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
  [2830] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(43), 1,
      anon_sym_for,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(105), 1,
      sym_expression,
    STATE(167), 1,
      sym_list_comprehension,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(165), 2,
      sym_for_clause,
      sym_if_clause,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [2920] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      sym_identifier,
    ACTIONS(259), 1,
      anon_sym_SEMI,
    ACTIONS(262), 1,
      anon_sym_module,
    ACTIONS(265), 1,
      anon_sym_function,
    ACTIONS(268), 1,
      anon_sym_include,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_RBRACE,
    ACTIONS(276), 1,
      anon_sym_for,
    ACTIONS(279), 1,
      anon_sym_intersection_for,
    ACTIONS(282), 1,
      anon_sym_let,
    ACTIONS(285), 1,
      anon_sym_assign,
    ACTIONS(288), 1,
      anon_sym_if,
    ACTIONS(294), 1,
      anon_sym_assert,
    ACTIONS(297), 1,
      anon_sym_DOLLAR,
    STATE(22), 1,
      sym_special_variable,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    STATE(212), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
    ACTIONS(291), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(46), 15,
      sym__item,
      sym_module_declaration,
      sym_function_declaration,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
      aux_sym_union_block_repeat1,
  [3007] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_function,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(300), 1,
      anon_sym_SEMI,
    ACTIONS(302), 1,
      anon_sym_RBRACE,
    STATE(22), 1,
      sym_special_variable,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    STATE(212), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(48), 15,
      sym__item,
      sym_module_declaration,
      sym_function_declaration,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
      aux_sym_union_block_repeat1,
  [3094] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_module,
    ACTIONS(13), 1,
      anon_sym_function,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(304), 1,
      anon_sym_SEMI,
    ACTIONS(306), 1,
      anon_sym_RBRACE,
    STATE(22), 1,
      sym_special_variable,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    STATE(212), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(46), 15,
      sym__item,
      sym_module_declaration,
      sym_function_declaration,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
      aux_sym_union_block_repeat1,
  [3181] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(308), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(111), 1,
      sym__variable_name,
    STATE(118), 1,
      sym_expression,
    STATE(194), 1,
      sym_assignment,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 10,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
  [3266] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(310), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(111), 1,
      sym__variable_name,
    STATE(118), 1,
      sym_expression,
    STATE(194), 1,
      sym_assignment,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 10,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
  [3351] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(312), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
    ACTIONS(314), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_assert,
      sym_identifier,
  [3424] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(316), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(108), 1,
      sym_expression,
    STATE(111), 1,
      sym__variable_name,
    STATE(191), 1,
      sym_assignment,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 10,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
  [3509] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(111), 1,
      sym__variable_name,
    STATE(118), 1,
      sym_expression,
    STATE(194), 1,
      sym_assignment,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 10,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
  [3591] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    ACTIONS(318), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(126), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [3671] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(21), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [3748] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(17), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [3825] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(135), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [3902] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(136), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [3979] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(127), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4056] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(120), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4133] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(24), 1,
      sym_expression,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4210] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(12), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4287] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(23), 1,
      sym_expression,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4364] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(13), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4441] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(106), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4518] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(109), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4595] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(131), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4672] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(130), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4749] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(119), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4826] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4903] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(14), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [4980] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(16), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5057] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(10), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5134] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(133), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5211] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(51), 1,
      sym_expression,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5288] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(11), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5365] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(9), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5442] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(18), 1,
      sym_expression,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5519] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(137), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5596] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(134), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5673] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(37), 1,
      sym_identifier,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_function,
    ACTIONS(45), 1,
      anon_sym_let,
    ACTIONS(49), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_DASH,
    ACTIONS(59), 1,
      anon_sym_PLUS,
    ACTIONS(61), 1,
      sym_string,
    ACTIONS(67), 1,
      sym_undef,
    STATE(22), 1,
      sym_special_variable,
    STATE(56), 1,
      sym__assert_clause,
    STATE(129), 1,
      sym_expression,
    ACTIONS(63), 2,
      sym_decimal,
      sym_float,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(25), 5,
      sym_function,
      sym_range,
      sym_list,
      sym_number,
      sym_boolean,
    STATE(35), 11,
      sym_parenthesized_expression,
      sym_let_expression,
      sym_literal,
      sym_function_call,
      sym_index_expression,
      sym_dot_index_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_ternary_expression,
      sym_assert_expression,
      sym__variable_name,
  [5750] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(125), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [5812] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(324), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(138), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [5874] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(326), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(113), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [5936] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(114), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [5998] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(330), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(116), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6060] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(332), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(123), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6122] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(334), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(110), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6184] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(336), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(124), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6246] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(338), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(121), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6308] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_for,
    ACTIONS(23), 1,
      anon_sym_intersection_for,
    ACTIONS(25), 1,
      anon_sym_let,
    ACTIONS(27), 1,
      anon_sym_assign,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_assert,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(340), 1,
      anon_sym_SEMI,
    STATE(84), 1,
      sym_modifier,
    STATE(85), 1,
      sym_module_call,
    STATE(86), 1,
      sym__assert_clause,
    ACTIONS(31), 4,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    STATE(128), 11,
      sym__statement,
      sym_include_statement,
      sym_union_block,
      sym_for_block,
      sym_intersection_for_block,
      sym_let_block,
      sym_assign_block,
      sym_if_block,
      sym_modifier_chain,
      sym_transform_chain,
      sym_assert_statement,
  [6370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(344), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(342), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(348), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(346), 16,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(352), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(350), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(356), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(354), 16,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(358), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(364), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(362), 16,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(368), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(366), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(372), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(370), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(376), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(374), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(378), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(384), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(382), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(388), 11,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(386), 15,
      anon_sym_function,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [6785] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(390), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [6842] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(392), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [6899] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(394), 1,
      anon_sym_COMMA,
    ACTIONS(396), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    STATE(192), 1,
      aux_sym__assert_clause_repeat1,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6959] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(400), 1,
      anon_sym_COLON,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(398), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [7017] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(402), 1,
      anon_sym_COMMA,
    ACTIONS(404), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    STATE(182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7077] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(406), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [7133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(410), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 1,
      anon_sym_EQ,
    ACTIONS(175), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
    ACTIONS(173), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_QMARK,
  [7193] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(398), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [7248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(414), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(416), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(418), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(420), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(422), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(424), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(428), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(430), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(432), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7393] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(434), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [7448] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(436), 1,
      anon_sym_COLON,
    ACTIONS(438), 1,
      anon_sym_RBRACK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7505] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(440), 1,
      anon_sym_COMMA,
    ACTIONS(442), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(446), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(448), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(450), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(454), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(458), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(462), 12,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      sym_identifier,
  [7707] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(464), 1,
      anon_sym_COMMA,
    ACTIONS(466), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7764] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(468), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [7819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 1,
      anon_sym_else,
    ACTIONS(470), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(472), 11,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [7850] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(476), 1,
      anon_sym_SEMI,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7904] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(478), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7958] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(480), 1,
      anon_sym_SEMI,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(484), 11,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [8040] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(486), 1,
      anon_sym_COLON,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8094] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(488), 1,
      anon_sym_RBRACK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8148] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8202] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(492), 1,
      anon_sym_RBRACK,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8256] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_LBRACK,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(91), 1,
      anon_sym_AMP_AMP,
    ACTIONS(99), 1,
      anon_sym_SLASH,
    ACTIONS(101), 1,
      anon_sym_CARET,
    ACTIONS(103), 1,
      anon_sym_QMARK,
    ACTIONS(494), 1,
      anon_sym_SEMI,
    STATE(30), 1,
      sym_arguments,
    ACTIONS(81), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(87), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(93), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(95), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(97), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(498), 11,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [8338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(500), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(504), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(139), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(510), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(508), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(514), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(512), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(518), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(516), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(522), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(520), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(526), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(524), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
    ACTIONS(530), 11,
      anon_sym_module,
      anon_sym_function,
      anon_sym_include,
      anon_sym_use,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [8581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(534), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(532), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(538), 6,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_string,
    ACTIONS(536), 13,
      anon_sym_function,
      anon_sym_for,
      anon_sym_let,
      anon_sym_if,
      anon_sym_each,
      anon_sym_DASH,
      anon_sym_assert,
      sym_identifier,
      sym_decimal,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
  [8635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    ACTIONS(540), 8,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [8657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_PERCENT,
    ACTIONS(544), 8,
      anon_sym_include,
      anon_sym_for,
      anon_sym_intersection_for,
      anon_sym_let,
      anon_sym_assign,
      anon_sym_if,
      anon_sym_assert,
      sym_identifier,
  [8679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(550), 1,
      anon_sym_COMMA,
    ACTIONS(552), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(184), 1,
      sym__variable_name,
    STATE(186), 2,
      sym__parameter_declaration,
      sym_assignment,
  [8705] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(554), 1,
      anon_sym_SEMI,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(169), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(184), 1,
      sym__variable_name,
    STATE(201), 2,
      sym__parameter_declaration,
      sym_assignment,
  [8753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(184), 1,
      sym__variable_name,
    STATE(201), 2,
      sym__parameter_declaration,
      sym_assignment,
  [8776] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(562), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(177), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8798] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(187), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    STATE(22), 1,
      sym_special_variable,
    STATE(184), 1,
      sym__variable_name,
    STATE(201), 2,
      sym__parameter_declaration,
      sym_assignment,
  [8840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(183), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_special_variable,
    STATE(174), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_DOLLAR,
    ACTIONS(548), 1,
      sym_identifier,
    STATE(22), 1,
      sym_special_variable,
    STATE(180), 1,
      sym_assignment,
    STATE(213), 1,
      sym__variable_name,
  [8903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [8913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [8923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(574), 1,
      anon_sym_else,
    ACTIONS(572), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [8935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [8945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(578), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [8955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [8965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(582), 1,
      anon_sym_COMMA,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
    ACTIONS(580), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [8979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_SEMI,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(589), 1,
      anon_sym_RPAREN,
    STATE(170), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [8995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(591), 1,
      anon_sym_SEMI,
    ACTIONS(593), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(595), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    ACTIONS(129), 1,
      anon_sym_EQ,
    STATE(151), 1,
      sym_arguments,
  [9037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(597), 1,
      anon_sym_LPAREN,
    STATE(5), 2,
      sym_parenthesized_assignments,
      sym_condition_update_clause,
  [9048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(599), 1,
      anon_sym_RPAREN,
    STATE(189), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    ACTIONS(601), 1,
      anon_sym_COMMA,
    STATE(181), 1,
      aux_sym_parameters_declaration_repeat1,
  [9074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 1,
      anon_sym_RPAREN,
    ACTIONS(603), 1,
      anon_sym_COMMA,
    STATE(176), 1,
      aux_sym_arguments_repeat1,
  [9087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_COMMA,
    ACTIONS(610), 1,
      anon_sym_RBRACK,
    STATE(193), 1,
      aux_sym_list_repeat1,
  [9113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(593), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(580), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_COMMA,
    ACTIONS(615), 1,
      anon_sym_RPAREN,
    STATE(181), 1,
      aux_sym_parameters_declaration_repeat1,
  [9148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_RPAREN,
    ACTIONS(617), 1,
      anon_sym_COMMA,
    STATE(176), 1,
      aux_sym_arguments_repeat1,
  [9161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(619), 1,
      anon_sym_RPAREN,
    STATE(171), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 1,
      anon_sym_EQ,
    ACTIONS(621), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(625), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_COMMA,
    ACTIONS(629), 1,
      anon_sym_RPAREN,
    STATE(175), 1,
      aux_sym_parameters_declaration_repeat1,
  [9211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(589), 1,
      anon_sym_RPAREN,
    STATE(179), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
    ACTIONS(631), 1,
      anon_sym_COMMA,
    STATE(188), 1,
      aux_sym__assert_clause_repeat1,
  [9237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    ACTIONS(634), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym_parenthesized_assignments_repeat1,
  [9250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_COMMA,
    ACTIONS(639), 1,
      anon_sym_RBRACK,
    STATE(190), 1,
      aux_sym_list_repeat1,
  [9263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(402), 1,
      anon_sym_COMMA,
    ACTIONS(404), 1,
      anon_sym_RPAREN,
    STATE(182), 1,
      aux_sym_arguments_repeat1,
  [9276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(394), 1,
      anon_sym_COMMA,
    ACTIONS(641), 1,
      anon_sym_RPAREN,
    STATE(188), 1,
      aux_sym__assert_clause_repeat1,
  [9289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_RBRACK,
    ACTIONS(643), 1,
      anon_sym_COMMA,
    STATE(190), 1,
      aux_sym_list_repeat1,
  [9302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(434), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_LPAREN,
    STATE(83), 1,
      sym_parameters_declaration,
  [9320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    STATE(88), 1,
      sym_parenthesized_assignments,
  [9330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_parenthesized_assignments,
  [9340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [9348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_LPAREN,
    STATE(151), 1,
      sym_arguments,
  [9358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 1,
      anon_sym_LPAREN,
    STATE(6), 1,
      sym_parenthesized_expression,
  [9368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_LPAREN,
    STATE(208), 1,
      sym_parameters_declaration,
  [9386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    STATE(89), 1,
      sym_parenthesized_assignments,
  [9396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_LPAREN,
    STATE(77), 1,
      sym_parameters_declaration,
  [9406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    STATE(82), 1,
      sym_parenthesized_assignments,
  [9416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_parenthesized_expression,
  [9426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LPAREN,
    STATE(78), 1,
      sym_parenthesized_assignments,
  [9436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 1,
      anon_sym_EQ,
  [9443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 1,
      sym_identifier,
  [9450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      ts_builtin_sym_end,
  [9457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_RPAREN,
  [9464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_SEMI,
  [9471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 1,
      anon_sym_EQ,
  [9478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 1,
      sym_identifier,
  [9485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 1,
      anon_sym_LPAREN,
  [9492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 1,
      sym_include_path,
  [9499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_RPAREN,
  [9506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 1,
      sym_include_path,
  [9513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 1,
      sym_identifier,
  [9520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 98,
  [SMALL_STATE(4)] = 196,
  [SMALL_STATE(5)] = 294,
  [SMALL_STATE(6)] = 389,
  [SMALL_STATE(7)] = 484,
  [SMALL_STATE(8)] = 579,
  [SMALL_STATE(9)] = 674,
  [SMALL_STATE(10)] = 752,
  [SMALL_STATE(11)] = 810,
  [SMALL_STATE(12)] = 870,
  [SMALL_STATE(13)] = 934,
  [SMALL_STATE(14)] = 1012,
  [SMALL_STATE(15)] = 1078,
  [SMALL_STATE(16)] = 1172,
  [SMALL_STATE(17)] = 1230,
  [SMALL_STATE(18)] = 1308,
  [SMALL_STATE(19)] = 1386,
  [SMALL_STATE(20)] = 1436,
  [SMALL_STATE(21)] = 1506,
  [SMALL_STATE(22)] = 1578,
  [SMALL_STATE(23)] = 1628,
  [SMALL_STATE(24)] = 1702,
  [SMALL_STATE(25)] = 1766,
  [SMALL_STATE(26)] = 1815,
  [SMALL_STATE(27)] = 1864,
  [SMALL_STATE(28)] = 1913,
  [SMALL_STATE(29)] = 1962,
  [SMALL_STATE(30)] = 2011,
  [SMALL_STATE(31)] = 2060,
  [SMALL_STATE(32)] = 2109,
  [SMALL_STATE(33)] = 2158,
  [SMALL_STATE(34)] = 2249,
  [SMALL_STATE(35)] = 2298,
  [SMALL_STATE(36)] = 2347,
  [SMALL_STATE(37)] = 2396,
  [SMALL_STATE(38)] = 2487,
  [SMALL_STATE(39)] = 2536,
  [SMALL_STATE(40)] = 2585,
  [SMALL_STATE(41)] = 2634,
  [SMALL_STATE(42)] = 2683,
  [SMALL_STATE(43)] = 2732,
  [SMALL_STATE(44)] = 2781,
  [SMALL_STATE(45)] = 2830,
  [SMALL_STATE(46)] = 2920,
  [SMALL_STATE(47)] = 3007,
  [SMALL_STATE(48)] = 3094,
  [SMALL_STATE(49)] = 3181,
  [SMALL_STATE(50)] = 3266,
  [SMALL_STATE(51)] = 3351,
  [SMALL_STATE(52)] = 3424,
  [SMALL_STATE(53)] = 3509,
  [SMALL_STATE(54)] = 3591,
  [SMALL_STATE(55)] = 3671,
  [SMALL_STATE(56)] = 3748,
  [SMALL_STATE(57)] = 3825,
  [SMALL_STATE(58)] = 3902,
  [SMALL_STATE(59)] = 3979,
  [SMALL_STATE(60)] = 4056,
  [SMALL_STATE(61)] = 4133,
  [SMALL_STATE(62)] = 4210,
  [SMALL_STATE(63)] = 4287,
  [SMALL_STATE(64)] = 4364,
  [SMALL_STATE(65)] = 4441,
  [SMALL_STATE(66)] = 4518,
  [SMALL_STATE(67)] = 4595,
  [SMALL_STATE(68)] = 4672,
  [SMALL_STATE(69)] = 4749,
  [SMALL_STATE(70)] = 4826,
  [SMALL_STATE(71)] = 4903,
  [SMALL_STATE(72)] = 4980,
  [SMALL_STATE(73)] = 5057,
  [SMALL_STATE(74)] = 5134,
  [SMALL_STATE(75)] = 5211,
  [SMALL_STATE(76)] = 5288,
  [SMALL_STATE(77)] = 5365,
  [SMALL_STATE(78)] = 5442,
  [SMALL_STATE(79)] = 5519,
  [SMALL_STATE(80)] = 5596,
  [SMALL_STATE(81)] = 5673,
  [SMALL_STATE(82)] = 5750,
  [SMALL_STATE(83)] = 5812,
  [SMALL_STATE(84)] = 5874,
  [SMALL_STATE(85)] = 5936,
  [SMALL_STATE(86)] = 5998,
  [SMALL_STATE(87)] = 6060,
  [SMALL_STATE(88)] = 6122,
  [SMALL_STATE(89)] = 6184,
  [SMALL_STATE(90)] = 6246,
  [SMALL_STATE(91)] = 6308,
  [SMALL_STATE(92)] = 6370,
  [SMALL_STATE(93)] = 6405,
  [SMALL_STATE(94)] = 6440,
  [SMALL_STATE(95)] = 6475,
  [SMALL_STATE(96)] = 6510,
  [SMALL_STATE(97)] = 6545,
  [SMALL_STATE(98)] = 6580,
  [SMALL_STATE(99)] = 6615,
  [SMALL_STATE(100)] = 6649,
  [SMALL_STATE(101)] = 6683,
  [SMALL_STATE(102)] = 6717,
  [SMALL_STATE(103)] = 6751,
  [SMALL_STATE(104)] = 6785,
  [SMALL_STATE(105)] = 6842,
  [SMALL_STATE(106)] = 6899,
  [SMALL_STATE(107)] = 6959,
  [SMALL_STATE(108)] = 7017,
  [SMALL_STATE(109)] = 7077,
  [SMALL_STATE(110)] = 7133,
  [SMALL_STATE(111)] = 7162,
  [SMALL_STATE(112)] = 7193,
  [SMALL_STATE(113)] = 7248,
  [SMALL_STATE(114)] = 7277,
  [SMALL_STATE(115)] = 7306,
  [SMALL_STATE(116)] = 7335,
  [SMALL_STATE(117)] = 7364,
  [SMALL_STATE(118)] = 7393,
  [SMALL_STATE(119)] = 7448,
  [SMALL_STATE(120)] = 7505,
  [SMALL_STATE(121)] = 7562,
  [SMALL_STATE(122)] = 7591,
  [SMALL_STATE(123)] = 7620,
  [SMALL_STATE(124)] = 7649,
  [SMALL_STATE(125)] = 7678,
  [SMALL_STATE(126)] = 7707,
  [SMALL_STATE(127)] = 7764,
  [SMALL_STATE(128)] = 7819,
  [SMALL_STATE(129)] = 7850,
  [SMALL_STATE(130)] = 7904,
  [SMALL_STATE(131)] = 7958,
  [SMALL_STATE(132)] = 8012,
  [SMALL_STATE(133)] = 8040,
  [SMALL_STATE(134)] = 8094,
  [SMALL_STATE(135)] = 8148,
  [SMALL_STATE(136)] = 8202,
  [SMALL_STATE(137)] = 8256,
  [SMALL_STATE(138)] = 8310,
  [SMALL_STATE(139)] = 8338,
  [SMALL_STATE(140)] = 8365,
  [SMALL_STATE(141)] = 8392,
  [SMALL_STATE(142)] = 8419,
  [SMALL_STATE(143)] = 8446,
  [SMALL_STATE(144)] = 8473,
  [SMALL_STATE(145)] = 8500,
  [SMALL_STATE(146)] = 8527,
  [SMALL_STATE(147)] = 8554,
  [SMALL_STATE(148)] = 8581,
  [SMALL_STATE(149)] = 8608,
  [SMALL_STATE(150)] = 8635,
  [SMALL_STATE(151)] = 8657,
  [SMALL_STATE(152)] = 8679,
  [SMALL_STATE(153)] = 8705,
  [SMALL_STATE(154)] = 8730,
  [SMALL_STATE(155)] = 8753,
  [SMALL_STATE(156)] = 8776,
  [SMALL_STATE(157)] = 8798,
  [SMALL_STATE(158)] = 8820,
  [SMALL_STATE(159)] = 8840,
  [SMALL_STATE(160)] = 8862,
  [SMALL_STATE(161)] = 8884,
  [SMALL_STATE(162)] = 8903,
  [SMALL_STATE(163)] = 8913,
  [SMALL_STATE(164)] = 8923,
  [SMALL_STATE(165)] = 8935,
  [SMALL_STATE(166)] = 8945,
  [SMALL_STATE(167)] = 8955,
  [SMALL_STATE(168)] = 8965,
  [SMALL_STATE(169)] = 8979,
  [SMALL_STATE(170)] = 8995,
  [SMALL_STATE(171)] = 9011,
  [SMALL_STATE(172)] = 9024,
  [SMALL_STATE(173)] = 9037,
  [SMALL_STATE(174)] = 9048,
  [SMALL_STATE(175)] = 9061,
  [SMALL_STATE(176)] = 9074,
  [SMALL_STATE(177)] = 9087,
  [SMALL_STATE(178)] = 9100,
  [SMALL_STATE(179)] = 9113,
  [SMALL_STATE(180)] = 9126,
  [SMALL_STATE(181)] = 9135,
  [SMALL_STATE(182)] = 9148,
  [SMALL_STATE(183)] = 9161,
  [SMALL_STATE(184)] = 9174,
  [SMALL_STATE(185)] = 9185,
  [SMALL_STATE(186)] = 9198,
  [SMALL_STATE(187)] = 9211,
  [SMALL_STATE(188)] = 9224,
  [SMALL_STATE(189)] = 9237,
  [SMALL_STATE(190)] = 9250,
  [SMALL_STATE(191)] = 9263,
  [SMALL_STATE(192)] = 9276,
  [SMALL_STATE(193)] = 9289,
  [SMALL_STATE(194)] = 9302,
  [SMALL_STATE(195)] = 9310,
  [SMALL_STATE(196)] = 9320,
  [SMALL_STATE(197)] = 9330,
  [SMALL_STATE(198)] = 9340,
  [SMALL_STATE(199)] = 9348,
  [SMALL_STATE(200)] = 9358,
  [SMALL_STATE(201)] = 9368,
  [SMALL_STATE(202)] = 9376,
  [SMALL_STATE(203)] = 9386,
  [SMALL_STATE(204)] = 9396,
  [SMALL_STATE(205)] = 9406,
  [SMALL_STATE(206)] = 9416,
  [SMALL_STATE(207)] = 9426,
  [SMALL_STATE(208)] = 9436,
  [SMALL_STATE(209)] = 9443,
  [SMALL_STATE(210)] = 9450,
  [SMALL_STATE(211)] = 9457,
  [SMALL_STATE(212)] = 9464,
  [SMALL_STATE(213)] = 9471,
  [SMALL_STATE(214)] = 9478,
  [SMALL_STATE(215)] = 9485,
  [SMALL_STATE(216)] = 9492,
  [SMALL_STATE(217)] = 9499,
  [SMALL_STATE(218)] = 9506,
  [SMALL_STATE(219)] = 9513,
  [SMALL_STATE(220)] = 9520,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 11),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 11),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 5),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 5),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 16),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 16),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_expression, 2, .production_id = 2),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_expression, 2, .production_id = 2),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_expression, 3, .production_id = 3),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_expression, 3, .production_id = 3),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_variable, 2),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_variable, 2),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_name, 1),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_name, 1),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number, 1),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number, 1),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 12),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 12),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, .production_id = 8),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, .production_id = 8),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, .production_id = 12),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, .production_id = 12),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(172),
  [186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(37),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(214),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(220),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(216),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(218),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(47),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(197),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(196),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(203),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(205),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(206),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(150),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(215),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(209),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 7, .production_id = 19),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 7, .production_id = 19),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 5, .production_id = 15),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 5, .production_id = 15),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(172),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(46),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(214),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(220),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(216),
  [271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(47),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_block_repeat1, 2),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(197),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(196),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(203),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(205),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(206),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(150),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(215),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_block_repeat1, 2), SHIFT_REPEAT(209),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 10),
  [314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 10),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters_declaration, 2),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters_declaration, 2),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_assignments, 2),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_assignments, 2),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters_declaration, 4),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters_declaration, 4),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_assignments, 4),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_assignments, 4),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters_declaration, 3),
  [360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters_declaration, 3),
  [362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_assignments, 3),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_assignments, 3),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters_declaration, 5),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters_declaration, 5),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assert_clause, 4, .production_id = 9),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assert_clause, 4, .production_id = 9),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assert_clause, 3),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assert_clause, 3),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assert_clause, 8, .production_id = 18),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assert_clause, 8, .production_id = 18),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assert_clause, 9, .production_id = 20),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assert_clause, 9, .production_id = 20),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assert_clause, 6, .production_id = 14),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assert_clause, 6, .production_id = 14),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_cell, 1),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_each, 2),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_cell, 1),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 5),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_for_block, 3, .production_id = 3),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_for_block, 3, .production_id = 3),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_chain, 2),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_chain, 2),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform_chain, 2),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_transform_chain, 2),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_block, 2),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_block, 2),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, .production_id = 2),
  [428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 2, .production_id = 2),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_statement, 2),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_statement, 2),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 5, .production_id = 13),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_block, 5, .production_id = 13),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_block, 3),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_block, 3),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_block, 3, .production_id = 3),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_block, 3, .production_id = 3),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_block, 3, .production_id = 3),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_block, 3, .production_id = 3),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assign_block, 3, .production_id = 3),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assign_block, 3, .production_id = 3),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__assert_clause_repeat1, 2),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 3, .production_id = 4),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_block, 3, .production_id = 4),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__item, 2),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__item, 2),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 7),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 7),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 7, .production_id = 24),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 7, .production_id = 24),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 6, .production_id = 21),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 6, .production_id = 21),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 6, .production_id = 22),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 6, .production_id = 22),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 5, .production_id = 9),
  [514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 5, .production_id = 9),
  [516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 7, .production_id = 23),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 7, .production_id = 23),
  [520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 9, .production_id = 28),
  [522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 9, .production_id = 28),
  [524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 7, .production_id = 25),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 7, .production_id = 25),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 2),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_statement, 2),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 8, .production_id = 26),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 8, .production_id = 26),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_update_clause, 8, .production_id = 27),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_update_clause, 8, .production_id = 27),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier, 1),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 1),
  [544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_call, 2, .production_id = 1),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_call, 2, .production_id = 1),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 5, .production_id = 17),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 3, .production_id = 4),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 1),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_cell, 3),
  [580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_assignments_repeat1, 2),
  [582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_assignments_repeat1, 2), SHIFT_REPEAT(161),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(53),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_declaration_repeat1, 2), SHIFT_REPEAT(158),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_declaration_repeat1, 2),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_declaration, 1, .production_id = 6),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assert_clause_repeat1, 2), SHIFT_REPEAT(59),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(8),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [655] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_openscad(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
